require 'spec_integration_helper'

describe "managing users" do

  let(:url) { 'http://foo.com' }
  let(:key) { '1234' }

  before do
    Gamifier.set :uri => url, :key => key
  end

  context "when user does not exists" do

    let(:user) { Gamifier.engine.users.build(user_attributes) }
    let(:users_response) { '"name": "Foo Bar","created_at": "2013-02-12T06:13:50-08:00","email": "user@foo.com","_id": "511a4e1e297c0148ed00238c","id": "511a4e1e297c0148ed00238c"' }

    before do
      stub_request(:post, "#{url}/#{key}/users.json").to_return(:status => 200, :body => users_response)
    end

    subject { user }

    it { should be_new }
    it { subject.save.should be_true }

  end

end
