require 'spec_helper'

describe Gamifier::Collection do

  let(:engine) { mock(Gamifier::Engine) }
  let(:collection) { Gamifier::Collection.new(engine, Gamifier::Model) }

  it "should have included the FinderMethods of the model" do
    Gamifier::Model::FinderMethods.public_instance_methods.each do |method|
      collection.should respond_to(method)
    end
  end

  it "should build a new object" do
    o = collection.build(:key => 'value')
    o.should be_a(Gamifier::Model)
  end

  it "should have the correct value" do
    o = collection.build(:key => 'value')
    o.key.should eq('value')
  end

  it { expect { collection.reset! }.to raise_error(ArgumentError) }

  it "should call destroy on each entry of the collection when calling #reset!" do
    model = mock(Gamifier::Model)
    model.should_receive(:destroy)
    collection.should_receive(:all).with(:site => "xyz").and_yield model
    collection.reset!(:site => "xyz")
  end

end
