require 'spec_helper'

describe Gamifier::DSL::ApiKey do

  let(:api_key) { Gamifier::DSL::ApiKey.new }
  let(:url) { 'http://foo.com' }
  let(:key) { '1234' }
  let(:enterprise_key) { '5678' }

  before do
    Gamifier.set :uri => url, :key => key, :enterprise_key =>  enterprise_key
  end

  describe "#initialize" do

    subject { api_key }

    its(:source) { should_not be_nil }

  end

  describe "#engine" do

    subject { api_key.engine }

    it { should_not eq(Gamifier.engine) }

  end

  describe "#method_missing" do

    let(:args) { 'bar' }
    let(:block) { lambda {|x| x} }

    it "should call on source" do
      api_key.source.should_receive(:foo).with(args, &block)
      api_key.foo(args, &block)
    end

  end

end
