require 'spec_helper'

describe Gamifier::Player do

  before do
    @engine = mock(Gamifier::Engine)
  end

  describe ".limit" do

    subject { Gamifier::ActivityDefinition.new.limit(1, 24.0) }

    its(:enable_rate_limiting) { should be_true }
    its(:bucket_max_capacity) { should eq(1) }
    its(:bucket_drain_rate) { should eq(1 / 24.0) }

  end

  describe ".limit_per_day" do

    subject { Gamifier::ActivityDefinition.new.limit_per_day(1) }

    its(:enable_rate_limiting) { should be_true }
    its(:bucket_max_capacity) { should eq(1) }
    its(:bucket_drain_rate) { should eq(1 / 24.0) }

  end

  describe ".limit_per_week" do

    subject { Gamifier::ActivityDefinition.new.limit_per_week(1) }

    its(:enable_rate_limiting) { should be_true }
    its(:bucket_max_capacity) { should eq(1) }
    its(:bucket_drain_rate) { should eq(1 / (24.0 * 7.0)) }

  end

  describe ".limit_once_per_day" do

    subject { Gamifier::ActivityDefinition.new.limit_once_per_day }

    its(:enable_rate_limiting) { should be_true }
    its(:bucket_max_capacity) { should eq(1) }
    its(:bucket_drain_rate) { should eq(1 / 24.0) }

  end

  describe ".limit_once_per_week" do

    subject { Gamifier::ActivityDefinition.new.limit_once_per_week }

    its(:enable_rate_limiting) { should be_true }
    its(:bucket_max_capacity) { should eq(1) }
    its(:bucket_drain_rate) { should eq(1 / (24.0 * 7.0)) }

  end

end
